=== debian/changelog ===
wabt (1.0.16-1) unstable; urgency=medium

  * New upstream version 1.0.16.

 -- Markus Koschany <apo@debian.org>  Thu, 28 May 2020 22:35:04 +0200
