## wabt 1.0.17

=== CMakeLists.txt ===
--- 
+++ 
@@ -342,55 +342,62 @@
   set_target_properties(wasm PROPERTIES CXX_VISIBILITY_PRESET hidden)
 endif ()
 
-if (NOT EMSCRIPTEN)
-  if (CODE_COVERAGE)
-    add_definitions("-fprofile-arcs -ftest-coverage")
-    if (COMPILER_IS_CLANG)
-      set(CMAKE_EXE_LINKER_FLAGS "--coverage")
-    else ()
-      link_libraries(gcov)
-    endif ()
-  endif ()
-
-  include(CMakeParseArguments)
-  function(wabt_executable)
-    cmake_parse_arguments(EXE "WITH_LIBM;INSTALL" "NAME" "SOURCES;LIBS" ${ARGN})
-
-    # Always link libwabt.
-    set(EXE_LIBS "${EXE_LIBS};wabt")
-
-    # Optionally link libm.
-    if (EXE_WITH_LIBM AND (COMPILER_IS_CLANG OR COMPILER_IS_GNU))
-      set(EXE_LIBS "${EXE_LIBS};m")
-    endif ()
-
-    add_executable(${EXE_NAME} ${EXE_SOURCES})
-    add_dependencies(everything ${EXE_NAME})
-    target_link_libraries(${EXE_NAME} ${EXE_LIBS})
-    set_property(TARGET ${EXE_NAME} PROPERTY CXX_STANDARD 11)
-    set_property(TARGET ${EXE_NAME} PROPERTY CXX_STANDARD_REQUIRED ON)
-
-    if (EXE_INSTALL)
-      list(APPEND WABT_EXECUTABLES ${EXE_NAME})
-      set(WABT_EXECUTABLES ${WABT_EXECUTABLES} PARENT_SCOPE)
-
-      add_custom_target(${EXE_NAME}-copy-to-bin ALL
-        COMMAND ${CMAKE_COMMAND} -E make_directory ${WABT_SOURCE_DIR}/bin
-        COMMAND ${CMAKE_COMMAND} -E copy $<TARGET_FILE:${EXE_NAME}> ${WABT_SOURCE_DIR}/bin
-        DEPENDS ${EXE_NAME}
-      )
-    endif ()
-  endfunction()
-
-  if (BUILD_TOOLS)
-    # wat2wasm
-    wabt_executable(
-      NAME wat2wasm
-      SOURCES src/tools/wat2wasm.cc
-      INSTALL
+if (CODE_COVERAGE)
+  add_definitions("-fprofile-arcs -ftest-coverage")
+  if (COMPILER_IS_CLANG)
+    set(CMAKE_EXE_LINKER_FLAGS "--coverage")
+  else ()
+    link_libraries(gcov)
+  endif ()
+endif ()
+
+include(CMakeParseArguments)
+function(wabt_executable)
+  cmake_parse_arguments(EXE "WITH_LIBM;INSTALL" "NAME" "SOURCES;LIBS" ${ARGN})
+
+  # Always link libwabt.
+  set(EXE_LIBS "${EXE_LIBS};wabt")
+
+  # Optionally link libm.
+  if (EXE_WITH_LIBM AND (COMPILER_IS_CLANG OR COMPILER_IS_GNU))
+    set(EXE_LIBS "${EXE_LIBS};m")
+  endif ()
+
+  add_executable(${EXE_NAME} ${EXE_SOURCES})
+  add_dependencies(everything ${EXE_NAME})
+  target_link_libraries(${EXE_NAME} ${EXE_LIBS})
+  set_property(TARGET ${EXE_NAME} PROPERTY CXX_STANDARD 11)
+  set_property(TARGET ${EXE_NAME} PROPERTY CXX_STANDARD_REQUIRED ON)
+
+  if (EXE_INSTALL)
+    list(APPEND WABT_EXECUTABLES ${EXE_NAME})
+    set(WABT_EXECUTABLES ${WABT_EXECUTABLES} PARENT_SCOPE)
+
+    add_custom_target(${EXE_NAME}-copy-to-bin ALL
+      COMMAND ${CMAKE_COMMAND} -E make_directory ${WABT_SOURCE_DIR}/bin
+      COMMAND ${CMAKE_COMMAND} -E copy $<TARGET_FILE:${EXE_NAME}> ${WABT_SOURCE_DIR}/bin
+      DEPENDS ${EXE_NAME}
     )
-
-    # wast2json
-    wabt_executable(
-      NAME wast2json
-      SOURCES src/tools/wast2json.cc
+  endif ()
+endfunction()
+
+if (BUILD_TOOLS)
+  # wat2wasm
+  wabt_executable(
+    NAME wat2wasm
+    SOURCES src/tools/wat2wasm.cc
+    INSTALL
+  )
+
+  # wast2json
+  wabt_executable(
+    NAME wast2json
+    SOURCES src/tools/wast2json.cc
+    INSTALL
+  )
+
+  # wasm2wat
+  wabt_executable(
+    NAME wasm2wat
+    SOURCES src/tools/wasm2wat.cc
+    INSTALL
