=== debian/changelog ===
wabt (1.0.17-1) unstable; urgency=medium

  * New upstream version 1.0.17.

 -- Markus Koschany <apo@debian.org>  Tue, 30 Jun 2020 21:45:57 +0200
