## wabt 1.0.19

=== CMakeLists.txt ===
--- 
+++ 
@@ -17,7 +17,17 @@
 cmake_minimum_required(VERSION 3.0.0)
 project(WABT VERSION 1.0.13)
 
+if (POLICY CMP0077)
+  cmake_policy(SET CMP0077 NEW)
+endif (POLICY CMP0077)
+
 set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
+
+# Check if wabt is being used directly or via add_subdirectory, FetchContent, etc
+set(WABT_MASTER_PROJECT OFF)
+if (CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
+  set(WABT_MASTER_PROJECT ON)
+endif()
 
 # For git users, attempt to generate a more useful version string
 if (EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/.git)
@@ -26,11 +36,17 @@
           "${GIT_EXECUTABLE}" --git-dir=${CMAKE_CURRENT_SOURCE_DIR}/.git describe --tags
           RESULT_VARIABLE
               GIT_VERSION_RESULT
+          ERROR_VARIABLE
+              GIT_VERSION_ERROR
           OUTPUT_VARIABLE
               GIT_VERSION
           OUTPUT_STRIP_TRAILING_WHITESPACE)
   if (${GIT_VERSION_RESULT})
-    message(WARNING "Error running git describe to determine version")
+    # Don't issue warning if we aren't the master project;
+    # just assume that whoever included us knows the version they are getting
+    if (WABT_MASTER_PROJECT)
+      message(WARNING "${GIT_VERSION_ERROR} Error running git describe to determine version")
+    endif()
   else ()
     set(CMAKE_PROJECT_VERSION "${CMAKE_PROJECT_VERSION} (${GIT_VERSION})")
   endif ()
@@ -369,35 +385,7 @@
   set_property(TARGET ${EXE_NAME} PROPERTY CXX_STANDARD 11)
   set_property(TARGET ${EXE_NAME} PROPERTY CXX_STANDARD_REQUIRED ON)
 
-  if (EXE_INSTALL)
-    list(APPEND WABT_EXECUTABLES ${EXE_NAME})
-    set(WABT_EXECUTABLES ${WABT_EXECUTABLES} PARENT_SCOPE)
-
-    add_custom_target(${EXE_NAME}-copy-to-bin ALL
-      COMMAND ${CMAKE_COMMAND} -E make_directory ${WABT_SOURCE_DIR}/bin
-      COMMAND ${CMAKE_COMMAND} -E copy $<TARGET_FILE:${EXE_NAME}> ${WABT_SOURCE_DIR}/bin
-      DEPENDS ${EXE_NAME}
-    )
-  endif ()
-endfunction()
-
-if (BUILD_TOOLS)
-  # wat2wasm
-  wabt_executable(
-    NAME wat2wasm
-    SOURCES src/tools/wat2wasm.cc
-    INSTALL
-  )
-
-  # wast2json
-  wabt_executable(
-    NAME wast2json
-    SOURCES src/tools/wast2json.cc
-    INSTALL
-  )
-
-  # wasm2wat
-  wabt_executable(
-    NAME wasm2wat
-    SOURCES src/tools/wasm2wat.cc
-    INSTALL
+  if (EMSCRIPTEN)
+    # build to JS for now, as node.js doesn't have code caching for wasm yet,
+    # and wasm startup times are slower
+    set_target_properties(${EXE_NAME}
