=== debian/changelog ===
wabt (1.0.19-1) unstable; urgency=medium

  * New upstream version 1.0.19.

 -- Markus Koschany <apo@debian.org>  Wed, 22 Jul 2020 13:38:30 +0200
