## wabt 1.0.20

=== CMakeLists.txt ===
--- 
+++ 
@@ -16,6 +16,7 @@
 
 cmake_minimum_required(VERSION 3.0.0)
 project(WABT VERSION 1.0.13)
+include(GNUInstallDirs)
 
 if (POLICY CMP0077)
   cmake_policy(SET CMP0077 NEW)
@@ -52,9 +53,14 @@
   endif ()
 endif ()
 
+if (NOT "${CMAKE_PROJECT_VERSION}")
+  set(CMAKE_PROJECT_VERSION ${PROJECT_VERSION})
+endif()
+
 option(BUILD_TESTS "Build GTest-based tests" ON)
 option(USE_SYSTEM_GTEST "Use system GTest, instead of building" OFF)
 option(BUILD_TOOLS "Build wabt commandline tools" ON)
+option(BUILD_FUZZ_TOOLS "Build tools that can repro fuzz bugs" OFF)
 option(BUILD_LIBWASM "Build libwasm" ON)
 option(USE_ASAN "Use address sanitizer" OFF)
 option(USE_MSAN "Use memory sanitizer" OFF)
@@ -120,14 +126,14 @@
   # disable warning C4800: implicit conversion from larger int to bool
   add_definitions(-W3 -wd4018 -wd4056 -wd4756 -wd4267 -wd4244 -wd4800 -D_CRT_SECURE_NO_WARNINGS -D_SCL_SECURE_NO_WARNINGS)
 
-  if (WERROR)
-    add_definitions(-WX)
-  endif ()
-
   if (NOT WITH_EXCEPTIONS)
     # disable exception use in C++ library
     add_definitions(-D_HAS_EXCEPTIONS=0)
   endif ()
+
+  # multi-core build.
+  add_definitions("/MP")
+
 else ()
   # disable -Wunused-parameter: this is really common when implementing
   #   interfaces, etc.
@@ -139,10 +145,6 @@
 
   set(CMAKE_CXX_EXTENSIONS OFF)
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -Wold-style-cast")
-
-  if (WERROR)
-    add_definitions(-Werror)
-  endif ()
 
   if (NOT WITH_EXCEPTIONS)
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-exceptions")
@@ -344,15 +346,36 @@
 
 add_library(wabt STATIC ${WABT_LIBRARY_SRC})
 
+IF (NOT WIN32)
+  add_library(wasm-rt-impl STATIC wasm2c/wasm-rt-impl.c wasm2c/wasm-rt-impl.h)
+  install(TARGETS wasm-rt-impl DESTINATION ${CMAKE_INSTALL_LIBDIR})
+  install(FILES wasm2c/wasm-rt.h wasm2c/wasm-rt-impl.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
+endif ()
+
+if (BUILD_FUZZ_TOOLS)
+  set(FUZZ_FLAGS "-fsanitize=fuzzer,address")
+  add_library(wabt-fuzz STATIC ${WABT_LIBRARY_SRC})
+  set_target_properties(wabt-fuzz
+    PROPERTIES
+    COMPILE_FLAGS "${FUZZ_FLAGS}"
+  )
+endif ()
+
 # libwasm, which implenents the wasm C API
 if (BUILD_LIBWASM)
   add_library(wasm SHARED ${WABT_LIBRARY_SRC} src/interp/interp-wasm-c-api.cc)
   target_link_libraries(wasm wabt)
   target_include_directories(wasm PUBLIC third_party/wasm-c-api/include)
   if (COMPILER_IS_MSVC)
+    if (WERROR)
+      target_compile_options(wasm PRIVATE -WX)
+    endif ()
     target_compile_definitions(wasm PRIVATE "WASM_API_EXTERN=__declspec(dllexport)")
   else ()
-    target_compile_options(wasm PRIVATE -Wno-old-style-cast)
+    if (WERROR)
+      target_compile_options(wasm PRIVATE -Werror)
+    endif ()
+    target_compile_options(wasm PRIVATE $<$<COMPILE_LANGUAGE:CXX>:-Wno-old-style-cast>)
     target_compile_definitions(wasm PRIVATE "WASM_API_EXTERN=__attribute__((visibility(\"default\")))")
   endif ()
   set_target_properties(wasm PROPERTIES CXX_VISIBILITY_PRESET hidden)
@@ -363,29 +386,3 @@
   if (COMPILER_IS_CLANG)
     set(CMAKE_EXE_LINKER_FLAGS "--coverage")
   else ()
-    link_libraries(gcov)
-  endif ()
-endif ()
-
-include(CMakeParseArguments)
-function(wabt_executable)
-  cmake_parse_arguments(EXE "WITH_LIBM;INSTALL" "NAME" "SOURCES;LIBS" ${ARGN})
-
-  # Always link libwabt.
-  set(EXE_LIBS "${EXE_LIBS};wabt")
-
-  # Optionally link libm.
-  if (EXE_WITH_LIBM AND (COMPILER_IS_CLANG OR COMPILER_IS_GNU))
-    set(EXE_LIBS "${EXE_LIBS};m")
-  endif ()
-
-  add_executable(${EXE_NAME} ${EXE_SOURCES})
-  add_dependencies(everything ${EXE_NAME})
-  target_link_libraries(${EXE_NAME} ${EXE_LIBS})
-  set_property(TARGET ${EXE_NAME} PROPERTY CXX_STANDARD 11)
-  set_property(TARGET ${EXE_NAME} PROPERTY CXX_STANDARD_REQUIRED ON)
-
-  if (EMSCRIPTEN)
-    # build to JS for now, as node.js doesn't have code caching for wasm yet,
-    # and wasm startup times are slower
-    set_target_properties(${EXE_NAME}
