=== debian/changelog ===
wabt (1.0.20-1) unstable; urgency=medium

  * New upstream version 1.0.20.

 -- Markus Koschany <apo@debian.org>  Wed, 11 Nov 2020 12:39:22 +0100
