## wabt 1.0.24

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,7 +15,7 @@
 #
 
 cmake_minimum_required(VERSION 3.0.0)
-project(WABT VERSION 1.0.13)
+project(WABT VERSION 1.0.24)
 include(GNUInstallDirs)
 
 if (POLICY CMP0077)
@@ -139,8 +139,7 @@
   #   interfaces, etc.
   # disable -Wpointer-arith: this is a GCC extension, and doesn't work in MSVC.
   add_definitions(
-    -Wall -Wextra -Wno-unused-parameter -Wpointer-arith -g
-    -Wuninitialized
+    -Wall -Wextra -Wno-unused-parameter -Wpointer-arith -Wuninitialized
   )
 
   set(CMAKE_CXX_EXTENSIONS OFF)
@@ -192,6 +191,8 @@
           set(TARGET_ARCH "i386")
         elseif (${FILE_OUTPUT} MATCHES "ARM")
           set(TARGET_ARCH "ARM")
+        elseif (${FILE_OUTPUT} MATCHES "IBM S/390")
+          set(TARGET_ARCH "s390x")
         else ()
           message(WARNING "Unknown target architecture!")
         endif ()
@@ -206,6 +207,9 @@
       # wasm doesn't allow for x87 floating point math
       add_definitions(-msse2 -mfpmath=sse)
     endif ()
+    if (TARGET_ARCH STREQUAL "s390x")
+      add_definitions(-DWABT_BIG_ENDIAN=1)
+    endif ()
   endif ()
 endif ()
 
@@ -235,7 +239,8 @@
     sanitizer(USE_UBSAN "-fsanitize=undefined -fno-sanitize-recover -fsanitize-blacklist=${UBSAN_BLACKLIST}")
   endif ()
   check_cxx_compiler_flag("-fsanitize=undefined -fno-sanitize-recover=all -Wall -Werror" HAS_UBSAN_RECOVER_ALL)
-  if (HAS_UBSAN_RECOVER_ALL)
+  # If we already setup UBSAN recover bare, setting it up again here will be an error.
+  if (NOT USE_SANITIZER AND HAS_UBSAN_RECOVER_ALL)
     sanitizer(USE_UBSAN "-fsanitize=undefined -fno-sanitize-recover=all -fsanitize-blacklist=${UBSAN_BLACKLIST}")
   endif ()
   if (NOT USE_SANITIZER)
@@ -376,13 +381,3 @@
       target_compile_options(wasm PRIVATE -Werror)
     endif ()
     target_compile_options(wasm PRIVATE $<$<COMPILE_LANGUAGE:CXX>:-Wno-old-style-cast>)
-    target_compile_definitions(wasm PRIVATE "WASM_API_EXTERN=__attribute__((visibility(\"default\")))")
-  endif ()
-  set_target_properties(wasm PROPERTIES CXX_VISIBILITY_PRESET hidden)
-endif ()
-
-if (CODE_COVERAGE)
-  add_definitions("-fprofile-arcs -ftest-coverage")
-  if (COMPILER_IS_CLANG)
-    set(CMAKE_EXE_LINKER_FLAGS "--coverage")
-  else ()
