=== debian/changelog ===
wabt (1.0.24-1) unstable; urgency=medium

  * New upstream version 1.0.24.
  * Declare compliance with Debian Policy 4.6.0.

 -- Markus Koschany <apo@debian.org>  Thu, 19 Aug 2021 13:04:10 +0200

wabt (1.0.21-1) experimental; urgency=medium

  * New upstream version 1.0.21.
  * Declare compliance with Debian Policy 4.5.1.

 -- Markus Koschany <apo@debian.org>  Sat, 13 Mar 2021 23:22:18 +0100
