## wabt 1.0.25

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,7 +15,7 @@
 #
 
 cmake_minimum_required(VERSION 3.0.0)
-project(WABT VERSION 1.0.24)
+project(WABT VERSION 1.0.25)
 include(GNUInstallDirs)
 
 if (POLICY CMP0077)
