=== debian/changelog ===
wabt (1.0.25-1) unstable; urgency=medium

  * New upstream version 1.0.25.

 -- Markus Koschany <apo@debian.org>  Sun, 19 Dec 2021 00:42:18 +0100

wabt (1.0.24-2) unstable; urgency=medium

  * Only install the examples and the README file into /usr/share/doc/wabt.
  * Install wasm-rt* files into /usr/src/wasm2c.
    Thanks to Jonas Smedegaard for the report. (Closes: #999872)

 -- Markus Koschany <apo@debian.org>  Fri, 19 Nov 2021 13:58:39 +0100
