## wabt 1.0.26

=== debian/changelog ===
wabt (1.0.26-1) unstable; urgency=medium

  * New upstream version 1.0.26.

 -- Markus Koschany <apo@debian.org>  Sun, 06 Feb 2022 22:11:53 +0100
