## wabt 1.0.27

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,8 +15,10 @@
 #
 
 cmake_minimum_required(VERSION 3.0.0)
-project(WABT VERSION 1.0.25)
+project(WABT LANGUAGES C CXX VERSION 1.0.27)
 include(GNUInstallDirs)
+
+set(CXX_STANDARD 17)
 
 if (POLICY CMP0077)
   cmake_policy(SET CMP0077 NEW)
@@ -125,6 +127,7 @@
   # disable warnings C4267 and C4244: conversion/truncation from larger to smaller type.
   # disable warning C4800: implicit conversion from larger int to bool
   add_definitions(-W3 -wd4018 -wd4056 -wd4756 -wd4267 -wd4244 -wd4800 -D_CRT_SECURE_NO_WARNINGS -D_SCL_SECURE_NO_WARNINGS)
+  add_definitions(/std:c++${CXX_STANDARD})
 
   if (NOT WITH_EXCEPTIONS)
     # disable exception use in C++ library
@@ -143,7 +146,7 @@
   )
 
   set(CMAKE_CXX_EXTENSIONS OFF)
-  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -Wold-style-cast")
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++${CXX_STANDARD} -Wold-style-cast")
 
   if (NOT WITH_EXCEPTIONS)
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-exceptions")
@@ -290,8 +293,6 @@
   src/filenames.cc
   src/generate-names.h
   src/generate-names.cc
-  src/hash-util.h
-  src/hash-util.cc
   src/ir.h
   src/ir.cc
   src/ir-util.h
@@ -316,8 +317,7 @@
   src/shared-validator.cc
   src/stream.h
   src/stream.cc
-  src/string-view.h
-  src/string-view.cc
+  src/string-util.h
   src/token.h
   src/token.cc
   src/tracing.h
