=== debian/changelog ===
wabt (1.0.27-1) unstable; urgency=medium

  * New upstream version 1.0.27.

 -- Markus Koschany <apo@debian.org>  Sat, 19 Feb 2022 23:05:06 +0100
