## wabt 1.0.28

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,7 +15,7 @@
 #
 
 cmake_minimum_required(VERSION 3.0.0)
-project(WABT LANGUAGES C CXX VERSION 1.0.27)
+project(WABT LANGUAGES C CXX VERSION 1.0.28)
 include(GNUInstallDirs)
 
 set(CXX_STANDARD 17)
@@ -121,6 +121,10 @@
 include_directories(${WABT_SOURCE_DIR} ${WABT_BINARY_DIR})
 
 if (COMPILER_IS_MSVC)
+  if (WERROR)
+    add_definitions(-WX)
+  endif ()
+
   # disable warning C4018: signed/unsigned mismatch
   # disable warning C4056, C4756: overflow in floating-point constant arithmetic
   #   seems to not like float compare w/ HUGE_VALF; bug?
@@ -138,6 +142,10 @@
   add_definitions("/MP")
 
 else ()
+  if (WERROR)
+    add_definitions(-Werror)
+  endif ()
+
   # disable -Wunused-parameter: this is really common when implementing
   #   interfaces, etc.
   # disable -Wpointer-arith: this is a GCC extension, and doesn't work in MSVC.
@@ -256,6 +264,8 @@
 add_custom_target(everything)
 
 set(WABT_LIBRARY_SRC
+  ${WABT_BINARY_DIR}/config.h
+
   src/apply-names.h
   src/apply-names.cc
   src/binary.h
@@ -276,7 +286,7 @@
   src/color.cc
   src/common.h
   src/common.cc
-  src/config.h
+  src/config.h.in
   src/config.cc
   src/decompiler.h
   src/decompiler-ast.h
@@ -372,12 +382,6 @@
   target_link_libraries(wasm wabt)
   target_include_directories(wasm PUBLIC third_party/wasm-c-api/include)
   if (COMPILER_IS_MSVC)
-    if (WERROR)
-      target_compile_options(wasm PRIVATE -WX)
-    endif ()
     target_compile_definitions(wasm PRIVATE "WASM_API_EXTERN=__declspec(dllexport)")
   else ()
-    if (WERROR)
-      target_compile_options(wasm PRIVATE -Werror)
-    endif ()
     target_compile_options(wasm PRIVATE $<$<COMPILE_LANGUAGE:CXX>:-Wno-old-style-cast>)
