=== debian/changelog ===
wabt (1.0.28-1) unstable; urgency=medium

  * New upstream version 1.0.28.

 -- Markus Koschany <apo@debian.org>  Thu, 28 Apr 2022 23:22:11 +0200
