## wabt 1.0.29

=== CMakeLists.txt ===
--- 
+++ 
@@ -14,11 +14,12 @@
 # limitations under the License.
 #
 
-cmake_minimum_required(VERSION 3.0.0)
-project(WABT LANGUAGES C CXX VERSION 1.0.28)
+cmake_minimum_required(VERSION 3.1.0)
+project(WABT LANGUAGES C CXX VERSION 1.0.29)
 include(GNUInstallDirs)
 
-set(CXX_STANDARD 17)
+set(CMAKE_CXX_STANDARD 17)
+set(CMAKE_CXX_STANDARD_REQUIRED ON)
 
 if (POLICY CMP0077)
   cmake_policy(SET CMP0077 NEW)
@@ -131,7 +132,6 @@
   # disable warnings C4267 and C4244: conversion/truncation from larger to smaller type.
   # disable warning C4800: implicit conversion from larger int to bool
   add_definitions(-W3 -wd4018 -wd4056 -wd4756 -wd4267 -wd4244 -wd4800 -D_CRT_SECURE_NO_WARNINGS -D_SCL_SECURE_NO_WARNINGS)
-  add_definitions(/std:c++${CXX_STANDARD})
 
   if (NOT WITH_EXCEPTIONS)
     # disable exception use in C++ library
@@ -154,7 +154,7 @@
   )
 
   set(CMAKE_CXX_EXTENSIONS OFF)
-  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++${CXX_STANDARD} -Wold-style-cast")
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wold-style-cast")
 
   if (NOT WITH_EXCEPTIONS)
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-exceptions")
