=== debian/changelog ===
wabt (1.0.29-1) unstable; urgency=medium

  * New upstream version 1.0.29.
  * Declare compliance with Debian Policy 4.6.1.

 -- Markus Koschany <apo@debian.org>  Sat, 28 May 2022 14:03:04 +0200
